Subject: Re: custom libtool installation and automake testsuite failures

From: Jim Meyering <[email-masked]>
Date: Sun, 06 Nov 2011 17:54:32 +0100

Stefano Lattarini wrote:

> On Sunday 06 November 2011, Jim Meyering wrote:
>> I install my own versions of m4, autoconf, automake, libtool, etc.,
>> using --prefix=/p, and I put /p/bin earlier in PATH than /usr/bin, etc.
>>
>> Because of that, I've always had to initialize
>> /p/share/aclocal/dirlist to contain /usr/share/aclocal.
>> Until today, I did it like this, so that uses of macros not
>> installed in my private hierarchy would still be found:
>>
>>     mkdir --verbose -p $(aclocal --print-ac-dir)
>>     echo /usr/share/aclocal >> $(aclocal --print-ac-dir)/dirlist
>>
>> Now I see that I must explicitly list /p/share/aclocal, too,
>> presumably before any other directory name,
>>
> That's weird; if I'm not mistaken, m4 files from ${acdir} should take
> precedence over those from directories listed in ${acdir}/dirlist ...
>
>> so I've done this:
>>
>>     mkdir --verbose -p $(aclocal --print-ac-dir)
>>     printf '%s/share/aclocal\n' /p /usr >> $(aclocal --print-ac-dir)/dirlist
>>
> I don't understand why this should be needed ...
>
>> With that, all of the tests on automake.master pass once again.
>>
> ... and I'm baffled by the fact it indeed works.
>
> Could you please try running a libtool-requiring test passing `--verbose'
> to the aclocal invocation there, to see what happens?

For the record, with /p/bin early in my path and self-built/installed
autoconf, automake, libtool-2.4.2 (with prefix=/p), with this, all
automake tests pass:

    $ cat /p/share/aclocal/dirlist
    /p/share/aclocal
    /usr/share/aclocal

If I change that to omit /p/share/aclocal,

    $ cat /p/share/aclocal/dirlist
    /usr/share/aclocal

Then 29 automake tests fail: